#ifndef _BL_H_
#define _BL_H_

#ifdef OLDGCC
/* 
 * a bug in the gcc port -- it doesn't save %a4, as it isn't 
 * supposed to be destroyed; SysTraps() however do this casually;
 * place these macros in EventHandler routines and callback functions.
 *
 * the egcs port doesn't have it anymore :-)
 */
register void *reg_a4 asm("%a4");
#  define CALLBACK_PROLOGUE \
    void *save_a4 = reg_a4; asm("move.l %%a5,%%a4; sub.l #edata,%%a4" : :);
#  define CALLBACK_EPILOGUE reg_a4 = save_a4;
#else
#  define CALLBACK_PROLOGUE
#  define CALLBACK_EPILOGUE
#endif

/*
 * definitions from bl.c
 */

typedef struct {
  UInt Version;
  Short matchDay;
  Short NumTeams;
  Short Spieltage;
} Prefs;
extern Prefs prefs;

extern char team[20][18];
extern Word programme[380];
extern ULong Datum[38];
extern Short DBNr;
extern SystemPreferencesType sysPrefs;

typedef struct {
  Byte Tore, GTore, Pkte, Spiele, Platz, HSpiele;
  Byte Gew, HGew, Rem, HRem, Ver, HVer, HTore, HGTore, HPkte;
  UShort Erg[38];
  long Index;
} MannStatus;
extern MannStatus MStatus[];

extern Short matchDay;

VoidPtr Id2Ptr(Word);
void BerechneTabelle(int);
void FrmMoveObject(Int, Int, Int);
CharPtr M1vSpNr(Word);
CharPtr M2vSpNr(Word);
void DrawBegegnungen(Boolean);
ListPtr FrmGetListPtr(Word frm, Word id);

/*
 * definitions from dbfuncs.c
 */
typedef struct {
  LocalID dbID;
  UInt cardNo;
  Char dbName[32];
  UInt dbAttr;
} SelectedDBInfo;

DmOpenRef CreateDatabase(CharPtr, Prefs*);
Err InitDatabase(DmOpenRef, Boolean);
Err OpenDatabase(UInt, LocalID);
void SaveStatus(Short);
void ChooseDB();
void SelectedDB(Short, SelectedDBInfo*);
void InitNewDatabase(DmOpenRef);
void DeleteDatabase(Short);

/*
 * definitions from edit.c
 */
void InitFormEdit();
Boolean EditFormHandleEvent(EventPtr);
void InitFormTeams();
Boolean TeamsFormHandleEvent(EventPtr);
Boolean EnterMannFormHandleEvent(EventPtr);
Boolean NewDBFormHandleEvent(EventPtr);

#endif
